﻿using UnityEngine;
using System.Collections;

public class CharacterMovement : MonoBehaviour {

	private Vector3 moveDirection = Vector3.zero;
	public float speed = 0.5F;

	private Animator animator;

	public static bool level1IsCompleted = false;
	public static bool level2IsCompleted= false;
	public static bool level3IsCompleted= false;
	public static bool level4IsCompleted= false;
	public static bool level5IsCompleted= false;
	public static bool level6IsCompleted= false;
	public static bool level7IsCompleted= false;
	public static bool level8IsCompleted= false;
	public static bool level11IsCompleted= false;

	public static bool level1IsAvailable = true;
	public static bool level2IsAvailable= false;
	public static bool level3IsAvailable= false;
	public static bool level4IsAvailable= false;
	public static bool level5IsAvailable= false;
	public static bool level6IsAvailable= false;
	public static bool level7IsAvailable= false;
	public static bool level8IsAvailable= false;
	public static bool level11IsAvailable= false;


	/*
	Value
		State
			0	South
			1	West
			2	North
			3	East

So if I’m editing the south state, and the south->east transition, then I want the condition to be ‘Direction equals 3’. 
The south to north transition would be ‘Direction equals 2’ and so on. 
	*/

	// Use this for initialization
	void Start () {
	
		animator = this.GetComponent<Animator> ();

	}
	
	// Update is called once per frame
	void Update () {
		/*
		moveDirection = new Vector3 (Input.GetAxis ("Horizontal"), Input.GetAxis ("Vertical"), 0);

		moveDirection = transform.TransformDirection (moveDirection);
		moveDirection *= speed;	

		this.gameObject.transform.Translate(moveDirection * speed * Time.deltaTime);
		*/
	
		//Debug.Log (level2IsAvailable);

		if(Input.GetKey(KeyCode.A))
		{
			animator.SetInteger ("Direction", 1);
			transform.Translate(Vector3.left * speed * Time.deltaTime);
		}
		else if(Input.GetKey(KeyCode.W))
		{
			animator.SetInteger ("Direction", 2);
			transform.Translate(Vector3.up * speed * Time.deltaTime);
		}
		else if(Input.GetKey(KeyCode.D))
		{
			animator.SetInteger ("Direction", 3);
			transform.Translate(Vector3.right * speed * Time.deltaTime);
		}
		else if(Input.GetKey(KeyCode.S))
		{
			animator.SetInteger ("Direction", 0);
			transform.Translate(Vector3.down * speed * Time.deltaTime);
		}

		
		if(Input.GetKeyDown(KeyCode.Space))
		{
			//interaction key
		}

		if(Input.GetKeyDown(KeyCode.R))
		{
			Application.LoadLevel(Application.loadedLevel);
		}

	}


	void OnTriggerEnter2D(Collider2D other)
	{

		if(other.gameObject.CompareTag("Box"))
		{
			Debug.Log ("asadsdad");
		}

		if(other.gameObject.CompareTag("Door"))
		{
			if(Application.loadedLevelName == "mainLevel")
			{
				if(other.gameObject.name == "1" && level1IsAvailable)
				{
					Application.LoadLevel(1);
				}

				if(other.gameObject.name == "2" && level2IsAvailable)
				{
					Application.LoadLevel(2);
				}

				if(other.gameObject.name == "3" && level3IsAvailable)
				{
					Application.LoadLevel(3);
				}

				if(other.gameObject.name == "4" && level4IsAvailable)
				{
					Application.LoadLevel(4);
				}

				if(other.gameObject.name == "5" && level5IsAvailable)
				{
					Application.LoadLevel(5);
				}

				if(other.gameObject.name == "6" && level6IsAvailable)
				{
					Application.LoadLevel(6);
				}
				if(other.gameObject.name == "7" && level7IsAvailable)
				{
					Application.LoadLevel(7);
				}
				if(other.gameObject.name == "8" && level8IsAvailable)
				{
					Application.LoadLevel(8);
				}
				if(other.gameObject.name == "9" && level7IsAvailable)
				{
					Application.LoadLevel(7);
				}
				if(other.gameObject.name == "10" && level8IsAvailable)
				{
					Application.LoadLevel(8);
				}
				if(other.gameObject.name == "11" && level11IsAvailable)
				{
					Application.LoadLevel(9);
				}
			}

			else if(Application.loadedLevelName == "level1" && level1IsCompleted)
			{
				Application.LoadLevel(0);
			}
			else if(Application.loadedLevelName == "level2" && level2IsCompleted)
			{
				Application.LoadLevel(0);
			}
			else if(Application.loadedLevelName == "level3" && level3IsCompleted)
			{
				Application.LoadLevel(0);
			}
			else if(Application.loadedLevelName == "level4" && level4IsCompleted)
			{
				Application.LoadLevel(0);
			}
			else if(Application.loadedLevelName == "level5" && level5IsCompleted)
			{
				Application.LoadLevel(0);
			}
			else if(Application.loadedLevelName == "level6" && level6IsCompleted)
			{
				Application.LoadLevel(0);
			}
			else if(Application.loadedLevelName == "level7" && level7IsCompleted)
			{
				Application.LoadLevel(0);
			}
			else if(Application.loadedLevelName == "level8" && level8IsCompleted)
			{
				Application.LoadLevel(0);
			}
			else if(Application.loadedLevelName == "level11" && level11IsCompleted)
			{
				Application.LoadLevel(0);
			}
		}


	}

	void OnControllerColliderHit(ControllerColliderHit hit) {

		float pushPower = 2.0F;

		
		if(hit.transform.name == "Box")
		{
			Rigidbody body = hit.collider.attachedRigidbody;
			if (body == null || body.isKinematic)
				return;
			
			if (hit.moveDirection.y < -0.3F)
				return;
			
			Vector3 pushDir = new Vector3(hit.moveDirection.x, 0, hit.moveDirection.z);
			body.velocity = pushDir * pushPower;
		}
		
	}
	
	
}
